Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ProbabilisticTreeCreaterTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ProbabilisticTreeCreaterTest.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ProbabilisticTreeCreaterTest.cs	(revision 3338)
@@ -11,16 +11,7 @@
   [TestClass]
   public class ProbabilisticTreeCreaterTest {
-    public ProbabilisticTreeCreaterTest() {
-      int populationSize = 1000;
-      randomTrees = new List<SymbolicExpressionTree>();
-      var grammar = new TestGrammar();
-      var random = new MersenneTwister();
-      for (int i = 0; i < populationSize; i++) {
-        randomTrees.Add(ProbabilisticTreeCreator.Create(random, grammar, 100, 10));
-      }
-      foreach (var tree in randomTrees)
-        Assert.IsTrue(grammar.IsValidExpression(tree));
-    }
-
+    private const int POPULATION_SIZE = 1000;
+    private const int MAX_TREE_SIZE = 100;
+    private const int MAX_TREE_HEIGHT = 10;
     private TestContext testContextInstance;
 
@@ -38,126 +29,40 @@
     }
 
-    private List<SymbolicExpressionTree> randomTrees;
-
-
-    private class Addition : Symbol { }
-    private class Subtraction : Symbol { }
-    private class Multiplication : Symbol { }
-    private class Division : Symbol { }
-    private class Terminal : Symbol { }
-
-    private class TestGrammar : DefaultSymbolicExpressionGrammar {
-      public TestGrammar()
-        : base(0, 0, 0, 0) {
-        Initialize();
+    [TestMethod()]
+    public void ProbabilisticTreeCreaterDistributionsTest() {
+      var randomTrees = new List<SymbolicExpressionTree>();
+      var grammar = Grammars.CreateSimpleArithmeticGrammar();
+      var random = new MersenneTwister();
+      for (int i = 0; i < POPULATION_SIZE; i++) {
+        randomTrees.Add(ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 0, 0));
       }
 
-      private void Initialize() {
-        var add = new Addition();
-        var sub = new Subtraction();
-        var mul = new Multiplication();
-        var div = new Division();
-        var terminal = new Terminal();
-
-        var allSymbols = new List<Symbol>() { add, sub, mul, div, terminal };
-        var functionSymbols = new List<Symbol>() { add, sub, mul, div };
-        allSymbols.ForEach(s => AddAllowedSymbols(StartSymbol, 0, s));
-
-        SetMinSubTreeCount(terminal, 0);
-        SetMaxSubTreeCount(terminal, 0);
-        int maxSubTrees = 3;
-        foreach (var functionSymbol in functionSymbols) {
-          SetMinSubTreeCount(functionSymbol, 1);
-          SetMaxSubTreeCount(functionSymbol, maxSubTrees);
-          foreach (var childSymbol in allSymbols) {
-            for (int argumentIndex = 0; argumentIndex < maxSubTrees; argumentIndex++) {
-              AddAllowedSymbols(functionSymbol, argumentIndex, childSymbol);
-            }
-          }
-        }
-      }
-    }
-
-    [TestMethod()]
-    public void ProbabilisticTreeCreaterSizeDistributionTest() {
-      int[] histogram = new int[105 / 5];
-      for (int i = 0; i < randomTrees.Count; i++) {
-        histogram[randomTrees[i].Size / 5]++;
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      for (int i = 0; i < histogram.Length; i++) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append("< "); strBuilder.Append((i + 1) * 5);
-        strBuilder.Append(": "); strBuilder.AppendFormat("{0:#0.00%}", histogram[i] / (double)randomTrees.Count);
-      }
-      Assert.Inconclusive("Size distribution of ProbabilisticTreeCreator: " + strBuilder);
-    }
-
-    [TestMethod()]
-    public void ProbabilisticTreeCreaterFunctionDistributionTest() {
-      Dictionary<Symbol, int> occurances = new Dictionary<Symbol, int>();
-      double n = 0.0;
-      for (int i = 0; i < randomTrees.Count; i++) {
-        foreach (var node in randomTrees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count > 0) {
-            if (!occurances.ContainsKey(node.Symbol))
-              occurances[node.Symbol] = 0;
-            occurances[node.Symbol]++;
-            n++;
-          }
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var function in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(function.Name); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
-      }
-      Assert.Inconclusive("Function distribution of ProbabilisticTreeCreator: " + strBuilder);
-    }
-
-    [TestMethod()]
-    public void ProbabilisticTreeCreaterNumberOfSubTreesDistributionTest() {
-      Dictionary<int, int> occurances = new Dictionary<int, int>();
-      double n = 0.0;
-      for (int i = 0; i < randomTrees.Count; i++) {
-        foreach (var node in randomTrees[i].IterateNodesPrefix()) {
-          if (!occurances.ContainsKey(node.SubTrees.Count))
-            occurances[node.SubTrees.Count] = 0;
-          occurances[node.SubTrees.Count]++;
-          n++;
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var arity in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(arity); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[arity] / n);
-      }
-      Assert.Inconclusive("Distribution of function arities of ProbabilisticTreeCreator: " + strBuilder);
+      foreach (var tree in randomTrees)
+        Assert.IsTrue(tree.IsValidExpression());
+      Assert.Inconclusive("ProbabilisticTreeCreator: " + Environment.NewLine +
+        Util.GetSizeDistributionString(randomTrees, 105, 5) + Environment.NewLine +
+        Util.GetFunctionDistributionString(randomTrees) + Environment.NewLine +
+        Util.GetNumberOfSubTreesDistributionString(randomTrees) + Environment.NewLine +
+        Util.GetTerminalDistributionString(randomTrees) + Environment.NewLine
+        );
     }
 
 
     [TestMethod()]
-    public void ProbabilisticTreeCreaterTerminalDistributionTest() {
-      Dictionary<Symbol, int> occurances = new Dictionary<Symbol, int>();
-      double n = 0.0;
-      for (int i = 0; i < randomTrees.Count; i++) {
-        foreach (var node in randomTrees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count == 0) {
-            if (!occurances.ContainsKey(node.Symbol))
-              occurances[node.Symbol] = 0;
-            occurances[node.Symbol]++;
-            n++;
-          }
-        }
+    public void ProbabilisticTreeCreaterWithAdfDistributionsTest() {
+      var randomTrees = new List<SymbolicExpressionTree>();
+      var grammar = Grammars.CreateArithmeticAndAdfGrammar();
+      var random = new MersenneTwister();
+      for (int i = 0; i < POPULATION_SIZE; i++) {
+        randomTrees.Add(ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3));
       }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var function in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(function.Name); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
-      }
-      Assert.Inconclusive("Terminal distribution of ProbabilisticTreeCreator: " + strBuilder);
+      foreach (var tree in randomTrees)
+        Assert.IsTrue(tree.IsValidExpression());
+      Assert.Inconclusive("ProbabilisticTreeCreator: " + Environment.NewLine +
+        Util.GetSizeDistributionString(randomTrees, 105, 5) + Environment.NewLine +
+        Util.GetFunctionDistributionString(randomTrees) + Environment.NewLine +
+        Util.GetNumberOfSubTreesDistributionString(randomTrees) + Environment.NewLine +
+        Util.GetTerminalDistributionString(randomTrees) + Environment.NewLine
+        );
     }
   }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/SubroutineCreaterTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/SubroutineCreaterTest.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/SubroutineCreaterTest.cs	(revision 3338)
@@ -13,6 +13,7 @@
   [TestClass]
   public class SubroutineCreaterTest {
-    public SubroutineCreaterTest() {
-    }
+    private static ISymbolicExpressionGrammar grammar;
+    private static List<SymbolicExpressionTree> subroutineTrees;
+    private static int failedEvents;
 
     private TestContext testContextInstance;
@@ -36,9 +37,10 @@
       subroutineTrees = new List<SymbolicExpressionTree>();
       int populationSize = 1000;
-      var grammar = new TestGrammar();
+      failedEvents = 0;
+      grammar = Grammars.CreateArithmeticAndAdfGrammar();
       var random = new MersenneTwister();
       for (int i = 0; i < populationSize; i++) {
         var randTree = ProbabilisticTreeCreator.Create(random, grammar, 100, 10);
-        Assert.IsTrue(grammar.IsValidExpression(randTree));
+        // PTC create is tested separately
         randomTrees.Add(randTree);
       }
@@ -47,5 +49,5 @@
         var par0 = (SymbolicExpressionTree)randomTrees[random.Next(populationSize)].Clone();
         bool success = SubroutineCreater.CreateSubroutine(random, par0, grammar, 100, 10, 3, 3);
-        Assert.IsTrue(grammar.IsValidExpression(par0));
+        if (!success) failedEvents++;
         subroutineTrees.Add(par0);
       }
@@ -53,113 +55,23 @@
 
 
-
-    private static List<SymbolicExpressionTree> subroutineTrees;
-    private static int failedEvents;
-
-    private class Addition : Symbol { }
-    private class Subtraction : Symbol { }
-    private class Multiplication : Symbol { }
-    private class Division : Symbol { }
-    private class Terminal : Symbol { }
-
-    private class TestGrammar : DefaultSymbolicExpressionGrammar {
-      public TestGrammar()
-        : base(0, 3, 0, 3) {
-        Initialize();
-      }
-
-      private void Initialize() {
-        var add = new Addition();
-        var sub = new Subtraction();
-        var mul = new Multiplication();
-        var div = new Division();
-        var terminal = new Terminal();
-
-        var defun = new Defun();
-        var invoke = new InvokeFunction();
-
-        var allSymbols = new List<Symbol>() { add, sub, mul, div, terminal, invoke };
-        var functionSymbols = new List<Symbol>() { add, sub, mul, div };
-        foreach (var symb in allSymbols) {
-          AddAllowedSymbols(StartSymbol, 0, symb);
-          AddAllowedSymbols(defun, 0, symb);
-        }
-        SetMinSubTreeCount(invoke, 0);
-        SetMaxSubTreeCount(invoke, 3);
-        for (int i = 0; i < 3; i++) {
-          allSymbols.ForEach(s => AddAllowedSymbols(invoke, i, s));
-        }
-        SetMinSubTreeCount(terminal, 0);
-        SetMaxSubTreeCount(terminal, 0);
-        int maxSubTrees = 3;
-        foreach (var functionSymbol in functionSymbols) {
-          SetMinSubTreeCount(functionSymbol, 1);
-          SetMaxSubTreeCount(functionSymbol, maxSubTrees);
-          foreach (var childSymbol in allSymbols) {
-            for (int argumentIndex = 0; argumentIndex < maxSubTrees; argumentIndex++) {
-              AddAllowedSymbols(functionSymbol, argumentIndex, childSymbol);
-            }
-          }
-        }
-      }
+    [TestMethod()]
+    public void SubroutineCreaterCreateTest() {
+      foreach (var tree in subroutineTrees)
+        Assert.IsTrue(grammar.IsValidExpression(tree));
     }
 
     [TestMethod()]
     public void SubroutineCreaterSizeDistributionTest() {
-      int[] histogram = new int[105 / 5];
-      for (int i = 0; i < subroutineTrees.Count; i++) {
-        histogram[subroutineTrees[i].Size / 5]++;
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      for (int i = 0; i < histogram.Length; i++) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append("< "); strBuilder.Append((i + 1) * 5);
-        strBuilder.Append(": "); strBuilder.AppendFormat("{0:#0.00%}", histogram[i] / (double)subroutineTrees.Count);
-      }
-      Assert.Inconclusive("Size distribution of SubroutineCreater: " + strBuilder);
+      Assert.Inconclusive("SubroutineCreater: " + Util.GetSizeDistributionString(subroutineTrees, 105, 5));
     }
 
     [TestMethod()]
     public void SubroutineCreaterFunctionDistributionTest() {
-      Dictionary<Symbol, int> occurances = new Dictionary<Symbol, int>();
-      double n = 0.0;
-      for (int i = 0; i < subroutineTrees.Count; i++) {
-        foreach (var node in subroutineTrees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count > 0) {
-            if (!occurances.ContainsKey(node.Symbol))
-              occurances[node.Symbol] = 0;
-            occurances[node.Symbol]++;
-            n++;
-          }
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var function in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(function.Name); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
-      }
-      Assert.Inconclusive("Function distribution of SubroutineCreater: " + strBuilder);
+      Assert.Inconclusive("SubroutineCreater: " + Util.GetFunctionDistributionString(subroutineTrees));
     }
 
     [TestMethod()]
     public void SubroutineCreaterNumberOfSubTreesDistributionTest() {
-      Dictionary<int, int> occurances = new Dictionary<int, int>();
-      double n = 0.0;
-      for (int i = 0; i < subroutineTrees.Count; i++) {
-        foreach (var node in subroutineTrees[i].IterateNodesPrefix()) {
-          if (!occurances.ContainsKey(node.SubTrees.Count))
-            occurances[node.SubTrees.Count] = 0;
-          occurances[node.SubTrees.Count]++;
-          n++;
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var arity in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(arity); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[arity] / n);
-      }
-      Assert.Inconclusive("Distribution of function arities of SubroutineCreater: " + strBuilder);
+      Assert.Inconclusive("SubroutineCreater: " + Util.GetNumberOfSubTreesDistributionString(subroutineTrees));
     }
 
@@ -167,23 +79,5 @@
     [TestMethod()]
     public void SubroutineCreaterTerminalDistributionTest() {
-      Dictionary<Symbol, int> occurances = new Dictionary<Symbol, int>();
-      double n = 0.0;
-      for (int i = 0; i < subroutineTrees.Count; i++) {
-        foreach (var node in subroutineTrees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count == 0) {
-            if (!occurances.ContainsKey(node.Symbol))
-              occurances[node.Symbol] = 0;
-            occurances[node.Symbol]++;
-            n++;
-          }
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var function in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(function.Name); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
-      }
-      Assert.Inconclusive("Terminal distribution of SubroutineCreater: " + strBuilder);
+      Assert.Inconclusive("SubroutineCreater: " + Util.GetTerminalDistributionString(subroutineTrees));
     }
   }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/SubtreeCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/SubtreeCrossoverTest.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/SubtreeCrossoverTest.cs	(revision 3338)
@@ -11,6 +11,7 @@
   [TestClass]
   public class SubtreeCrossoverTest {
-    public SubtreeCrossoverTest() {
-    }
+    private static ISymbolicExpressionGrammar grammar;
+    private static List<SymbolicExpressionTree> crossoverTrees;
+    private static double msPerCrossoverEvent;
 
     private TestContext testContextInstance;
@@ -34,8 +35,9 @@
       int populationSize = 1000;
       int generations = 5;
-      var grammar = new TestGrammar();
+      int failedEvents = 0;
+      grammar = Grammars.CreateArithmeticAndAdfGrammar();
       var random = new MersenneTwister();
       for (int i = 0; i < populationSize; i++) {
-        crossoverTrees.Add(ProbabilisticTreeCreator.Create(random, grammar, 100, 10));
+        crossoverTrees.Add(ProbabilisticTreeCreator.Create(random, grammar, 100, 10, 3, 3));
       }
       Stopwatch stopwatch = new Stopwatch();
@@ -47,5 +49,6 @@
           var par1 = (SymbolicExpressionTree)crossoverTrees[random.Next(populationSize)].Clone();
           bool success;
-          newPopulation.Add(SubtreeCrossover.Cross(random, grammar, par0, par1, 0.9, 100, 10, out success));
+          newPopulation.Add(SubtreeCrossover.Cross(random, par0, par1, 0.9, 100, 10, out success));
+          if (!success) failedEvents++;
         }
         crossoverTrees = newPopulation;
@@ -53,53 +56,13 @@
       stopwatch.Stop();
       foreach (var tree in crossoverTrees)
-        Assert.IsTrue(grammar.IsValidExpression(tree));
-      msPerCrossoverEvent = stopwatch.ElapsedMilliseconds / (double)populationSize / (double)generations;
+        Assert.IsTrue(tree.IsValidExpression());
+      msPerCrossoverEvent = stopwatch.ElapsedMilliseconds / (double)populationSize / (double)generations;      
     }
 
 
 
-    private static List<SymbolicExpressionTree> crossoverTrees;
-    private static double msPerCrossoverEvent;
-
-    private class Addition : Symbol { }
-    private class Subtraction : Symbol { }
-    private class Multiplication : Symbol { }
-    private class Division : Symbol { }
-    private class Terminal : Symbol { }
-
-    private class TestGrammar : DefaultSymbolicExpressionGrammar {
-      public TestGrammar()
-        : base(0, 0, 0, 0) {
-        Initialize();
-      }
-
-      private void Initialize() {
-        var add = new Addition();
-        var sub = new Subtraction();
-        var mul = new Multiplication();
-        var div = new Division();
-        var terminal = new Terminal();
-
-        var allSymbols = new List<Symbol>() { add, sub, mul, div, terminal };
-        var functionSymbols = new List<Symbol>() { add, sub, mul, div };
-        allSymbols.ForEach(s => AddAllowedSymbols(StartSymbol, 0, s));
-
-        SetMinSubTreeCount(terminal, 0);
-        SetMaxSubTreeCount(terminal, 0);
-        int maxSubTrees = 3;
-        foreach (var functionSymbol in functionSymbols) {
-          SetMinSubTreeCount(functionSymbol, 1);
-          SetMaxSubTreeCount(functionSymbol, maxSubTrees);
-          foreach (var childSymbol in allSymbols) {
-            for (int argumentIndex = 0; argumentIndex < maxSubTrees; argumentIndex++) {
-              AddAllowedSymbols(functionSymbol, argumentIndex, childSymbol);
-            }
-          }
-        }
-      }
-    }
-
     [TestMethod()]
     public void SubtreeCrossoverSpeed() {
+
       Assert.Inconclusive(msPerCrossoverEvent + " ms per crossover event (~" +
         Math.Round(1000.0 / (msPerCrossoverEvent)) + "crossovers / s)");
@@ -107,60 +70,16 @@
 
     [TestMethod()]
-    public void SubtreeCrossoverSizeDistributionTest() {
-      int[] histogram = new int[105 / 5];
-      for (int i = 0; i < crossoverTrees.Count; i++) {
-        histogram[crossoverTrees[i].Size / 5]++;
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      for (int i = 0; i < histogram.Length; i++) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append("< "); strBuilder.Append((i + 1) * 5);
-        strBuilder.Append(": "); strBuilder.AppendFormat("{0:#0.00%}", histogram[i] / (double)crossoverTrees.Count);
-      }
-      Assert.Inconclusive("Size distribution of SubtreeCrossover: " + strBuilder);
+    public void SubtreeCrossoverSizeDistributions() {
+      Assert.Inconclusive("SubtreeCrossover: " + Util.GetSizeDistributionString(crossoverTrees, 105, 5));
     }
 
     [TestMethod()]
     public void SubtreeCrossoverFunctionDistributionTest() {
-      Dictionary<Symbol, int> occurances = new Dictionary<Symbol, int>();
-      double n = 0.0;
-      for (int i = 0; i < crossoverTrees.Count; i++) {
-        foreach (var node in crossoverTrees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count > 0) {
-            if (!occurances.ContainsKey(node.Symbol))
-              occurances[node.Symbol] = 0;
-            occurances[node.Symbol]++;
-            n++;
-          }
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var function in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(function.Name); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
-      }
-      Assert.Inconclusive("Function distribution of SubtreeCrossover: " + strBuilder);
+      Assert.Inconclusive("SubtreeCrossover: " + Util.GetFunctionDistributionString(crossoverTrees));
     }
 
     [TestMethod()]
     public void SubtreeCrossoverNumberOfSubTreesDistributionTest() {
-      Dictionary<int, int> occurances = new Dictionary<int, int>();
-      double n = 0.0;
-      for (int i = 0; i < crossoverTrees.Count; i++) {
-        foreach (var node in crossoverTrees[i].IterateNodesPrefix()) {
-          if (!occurances.ContainsKey(node.SubTrees.Count))
-            occurances[node.SubTrees.Count] = 0;
-          occurances[node.SubTrees.Count]++;
-          n++;
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var arity in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(arity); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[arity] / n);
-      }
-      Assert.Inconclusive("Distribution of function arities of SubtreeCrossover: " + strBuilder);
+      Assert.Inconclusive("SubtreeCrossover: " + Util.GetNumberOfSubTreesDistributionString(crossoverTrees));
     }
 
@@ -168,23 +87,5 @@
     [TestMethod()]
     public void SubtreeCrossoverTerminalDistributionTest() {
-      Dictionary<Symbol, int> occurances = new Dictionary<Symbol, int>();
-      double n = 0.0;
-      for (int i = 0; i < crossoverTrees.Count; i++) {
-        foreach (var node in crossoverTrees[i].IterateNodesPrefix()) {
-          if (node.SubTrees.Count == 0) {
-            if (!occurances.ContainsKey(node.Symbol))
-              occurances[node.Symbol] = 0;
-            occurances[node.Symbol]++;
-            n++;
-          }
-        }
-      }
-      StringBuilder strBuilder = new StringBuilder();
-      foreach (var function in occurances.Keys) {
-        strBuilder.Append(Environment.NewLine);
-        strBuilder.Append(function.Name); strBuilder.Append(": ");
-        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
-      }
-      Assert.Inconclusive("Terminal distribution of SubtreeCrossover: " + strBuilder);
+      Assert.Inconclusive("SubtreeCrossover: " + Util.GetTerminalDistributionString(crossoverTrees));
     }
   }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Util.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Util.cs	(revision 3338)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Util.cs	(revision 3338)
@@ -0,0 +1,91 @@
+﻿using System;
+using System.Text;
+using System.Collections.Generic;
+using System.Linq;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Random;
+using System.Diagnostics;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_3._3.Tests {
+  public static class Util {
+    public static string GetSizeDistributionString(IList<SymbolicExpressionTree> trees, int maxTreeSize, int binSize) {
+      int[] histogram = new int[maxTreeSize / binSize];
+      for (int i = 0; i < trees.Count; i++) {
+        histogram[trees[i].Size / binSize]++;
+      }
+      StringBuilder strBuilder = new StringBuilder();
+      for (int i = 0; i < histogram.Length; i++) {
+        strBuilder.Append(Environment.NewLine);
+        strBuilder.Append("< "); strBuilder.Append((i + 1) * binSize);
+        strBuilder.Append(": "); strBuilder.AppendFormat("{0:#0.00%}", histogram[i] / (double)trees.Count);
+      }
+      return "Size distribution: " + strBuilder;
+    }
+
+    public static string GetFunctionDistributionString(IList<SymbolicExpressionTree> trees) {
+      Dictionary<string, int> occurances = new Dictionary<string, int>();
+      double n = 0.0;
+      for (int i = 0; i < trees.Count; i++) {
+        foreach (var node in trees[i].IterateNodesPrefix()) {
+          if (node.SubTrees.Count > 0) {
+            if (!occurances.ContainsKey(node.Symbol.Name))
+              occurances[node.Symbol.Name] = 0;
+            occurances[node.Symbol.Name]++;
+            n++;
+          }
+        }
+      }
+      StringBuilder strBuilder = new StringBuilder();
+      foreach (var function in occurances.Keys) {
+        strBuilder.Append(Environment.NewLine);
+        strBuilder.Append(function); strBuilder.Append(": ");
+        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
+      }
+      return "Function distribution: " + strBuilder;
+    }
+
+    public static string GetNumberOfSubTreesDistributionString(IList<SymbolicExpressionTree> trees) {
+      Dictionary<int, int> occurances = new Dictionary<int, int>();
+      double n = 0.0;
+      for (int i = 0; i < trees.Count; i++) {
+        foreach (var node in trees[i].IterateNodesPrefix()) {
+          if (!occurances.ContainsKey(node.SubTrees.Count))
+            occurances[node.SubTrees.Count] = 0;
+          occurances[node.SubTrees.Count]++;
+          n++;
+        }
+      }
+      StringBuilder strBuilder = new StringBuilder();
+      foreach (var arity in occurances.Keys) {
+        strBuilder.Append(Environment.NewLine);
+        strBuilder.Append(arity); strBuilder.Append(": ");
+        strBuilder.AppendFormat("{0:#0.00%}", occurances[arity] / n);
+      }
+      return "Distribution of function arities: " + strBuilder;
+    }
+
+
+    public static string GetTerminalDistributionString(IList<SymbolicExpressionTree> trees) {
+      Dictionary<string, int> occurances = new Dictionary<string, int>();
+      double n = 0.0;
+      for (int i = 0; i < trees.Count; i++) {
+        foreach (var node in trees[i].IterateNodesPrefix()) {
+          if (node.SubTrees.Count == 0) {
+            if (!occurances.ContainsKey(node.Symbol.Name))
+              occurances[node.Symbol.Name] = 0;
+            occurances[node.Symbol.Name]++;
+            n++;
+          }
+        }
+      }
+      StringBuilder strBuilder = new StringBuilder();
+      foreach (var function in occurances.Keys) {
+        strBuilder.Append(Environment.NewLine);
+        strBuilder.Append(function); strBuilder.Append(": ");
+        strBuilder.AppendFormat("{0:#0.00%}", occurances[function] / n);
+      }
+      return "Terminal distribution: " + strBuilder;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/AntInterpreter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/AntInterpreter.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/AntInterpreter.cs	(revision 3338)
@@ -29,4 +29,5 @@
 namespace HeuristicLab.Problems.ArtificialAnt {
   public class AntInterpreter {
+
     public int MaxTimeSteps { get; set; }
     public int FoodEaten { get; set; }
@@ -48,4 +49,14 @@
       }
     }
+
+    private SymbolicExpressionTreeNode FindMatchingFunction(string name) {
+      foreach (var defunBranch in expression.Root.SubTrees.OfType<DefunTreeNode>()) {
+        if (defunBranch.FunctionName == name) return defunBranch;
+      }
+      throw new ArgumentException("Function definition for " + name + " not found.");
+    }
+
+
+
     public int ElapsedTime { get; set; }
     private int currentDirection;
@@ -81,6 +92,8 @@
     public void Step() {
       // expression evaluated completly => start at root again
-      if (nodeStack.Count == 0)
+      if (nodeStack.Count == 0) {
         nodeStack.Push(Expression.ResultProducingExpression);
+      }
+
       var currentNode = nodeStack.Pop();
       if (currentNode.Symbol is Left) {
@@ -116,15 +129,15 @@
       } else if (currentNode.Symbol is InvokeFunction) {
         var invokeNode = currentNode as InvokeFunctionTreeNode;
-        var funBranch = (from node in expression.Root.SubTrees
-                         let funNode = node as DefunTreeNode
-                         where funNode != null
-                         where funNode.Name == invokeNode.InvokedFunctionName
-                         select funNode).FirstOrDefault();
-        if (funBranch == null) throw new InvalidOperationException("Can't find definition of function " + invokeNode.InvokedFunctionName);
-        nodeStack.Push(funBranch.SubTrees[0]);
-        foreach (var subTree in invokeNode.SubTrees)
-          nodeStack.Push(subTree);
-      } else if(currentNode.Symbol is Argument) {
-        // do nothing
+        var functionDefinition = (SymbolicExpressionTreeNode)FindMatchingFunction(invokeNode.InvokedFunctionName).Clone();
+        var argumentCutPoints = (from node in functionDefinition.IterateNodesPrefix()
+                                 where node.SubTrees.Count > 0
+                                 from subtree in node.SubTrees
+                                 where subtree is ArgumentTreeNode
+                                 select new { Parent = node, Argument = subtree.Symbol as Argument, ChildIndex = node.SubTrees.IndexOf(subtree) }).ToList();
+        foreach (var cutPoint in argumentCutPoints) {
+          cutPoint.Parent.RemoveSubTree(cutPoint.ChildIndex);
+          cutPoint.Parent.InsertSubTree(cutPoint.ChildIndex, (SymbolicExpressionTreeNode)invokeNode.SubTrees[cutPoint.Argument.ArgumentIndex].Clone());
+        }
+        nodeStack.Push(functionDefinition.SubTrees[0]);
       } else {
         throw new InvalidOperationException(currentNode.Symbol.ToString());
